/*
 * This file is part of Bielefeld Sensor Actuator Interface (BonSAI).
 *
 * Copyright(c) Frederic Siepmann
 * http://opensource.cit-ec.de/projects/bonsai
 *
 * This file may be licensed under the terms of of the
 * GNU Lesser General Public License Version 3 (the ``LGPL''),
 * or (at your option) any later version.
 *
 * Software distributed under the License is distributed
 * on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
 * express or implied. See the LGPL for the specific language
 * governing rights and limitations.
 *
 * You should have received a copy of the LGPL along with this
 * program. If not, go to http://www.gnu.org/licenses/lgpl.html
 * or write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * The development of this software was supported by the
 * Excellence Cluster EXC 277 Cognitive Interaction Technology.
 * The Excellence Cluster EXC 277 is a grant of the Deutsche
 * Forschungsgemeinschaft (DFG) in the context of the German
 * Excellence Initiative.
 *
 * Contributors: Leon Ziegler, Johannes Wienke, Norman Köster, Torben Töniges,
 *               Annika Rothert, Alexander Baumann, Marcel Dulisch, Maikel Linke,
 *               Marian Pohling, Lukas Twardon, Lukas Kettenbach
 */
package de.unibi.airobots.bonsai.skills;

import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import org.apache.commons.scxml.model.SCXML;
import org.apache.commons.scxml.model.State;
import org.apache.commons.scxml.model.TransitionTarget;
import org.apache.log4j.Logger;

/**
 * Class containing methods for SCXML validation.
 * 
 * @author nkoester
 */
public class SCXMLValidator {

    /**
     * Constructor.
     */
    public SCXMLValidator() {
        // nothing yet
    }

    /**
     * The log.
     */
    private Logger logger = Logger.getLogger(SCXMLValidator.class);

    /**
     * Validates a given SCXML based on the availability of the named skill
     * states.
     * 
     * @param aSCXML
     *            a already parsed and decoded SCXML
     * @return true for a validate SCXML; false for an invalidate SCXML
     */
    public boolean validateSCXML(SCXML aSCXML) {
//        Map map = aSCXML.getTargets();
//        Set keySet = map.keySet();
//        Iterator<TransitionTarget> it = keySet.iterator();
//        
//        while (it.hasNext()) {
//            logger.info("Found TranistionTarget: " + it.next().getId());
//        }
        
        
//            Map<?, State> m;
//            m = aSCXML.getChildren();
//            Iterator<State> it = m.values().iterator();
//            try {
//                while (it.hasNext()) {
//                    State aChild = it.next();
//                    String aChildName = aChild.getId();
//                    if (aChildName   == null) {
//                        continue;
//                    }
//                    try {
//                        Class.forName("de.unibi.airobots.bonsai.skills.states."
//                                        + aChildName, false, 
//                                        ClassLoader.getSystemClassLoader());
//                        // No exception => class exists
//                        logger.debug("Found state: " + aChildName);
//                    } catch (ClassNotFoundException e) {
//                        // Class does not exist
//                        logger.error("State " + aChildName
//                                + " was not found! Terminating.");
//                        return false;
//                    } 
//                }
//            } catch (ClassCastException e) {
//                // Class does not exist
//                logger.error("ToDo: Parallel states handling! " + e.toString());
//            }

            logger.debug("Parsing and validation complete.");
            return true;
    }
}
